<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) 2.1.18                                                  |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2016 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | Contentteller is not free software. You may not redistribute this file   |
// | or its derivatives without written permission.                           |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+
// | Patch #1                                                                 |
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Files
 * @copyright (C) 2002-2016 Esselbach Internet Solutions
 */

/**
 * function FilesDetails
 * A function to show the file details
 * @author Philipp Louis Esselbach
 */
function FilesDetails( $page )
{
	global $config, $database, $templates, $system, $security, $preferences, $user, $ipaddr, $uwrapper;
	list( $page_query, $opt ) = $system -> getpages( $page, 0 );
	$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_files SET file_views = file_views + 1, file_activity = now() WHERE file_seo = '" . $page_query . "' AND (file_website = '0' OR file_website = '" . intval( $config[ 'WEBSITE' ] ) . "')" );
	$templates -> initgzip();

	$files_theme = $preferences[ 'current_theme' ];
	if ( $preferences[ 'files_template_sets' ] or $preferences[ 'files_blocks' ] )
	{
		$query = $database -> dbquery( "SELECT file_templateset, file_blocks FROM " . DB_PREFIX . "esselbach_ct_files WHERE file_seo = '" . $page_query . "' AND (file_website = '0' OR file_website = '" . intval( $config[ 'WEBSITE' ] ) . "')" );
		if ( $database -> dbrows( $query ) )
		{
			list( $file_templateset, $file_blocks ) = $database -> dbrow( $query );
			if ( $file_templateset )
			{
				$files_theme = $file_templateset;
			}
			if ( $file_blocks )
			{
				$preferences[ 'site_blocks_override' ] = $file_blocks;
			}
		}
	}

	$main_templates = $templates -> preparetemplates( "'site_header','site_footer','site_menu_header','site_menu_item_header','site_menu_sub_item_header','site_menu_sub_item_footer','site_menu_item_footer','site_menu_item_admin','site_menu_footer','site_header_alt','site_footer_alt','site_advertisement_header','site_advertisement_list','site_advertisement_footer','site_block','site_block_alt1','site_block_alt2','site_login_anon','site_login_user','site_login_cookie','site_invalid_form','site_social','files_header','files_details_header','files_teaserimage','files_details','files_details_limitations','files_details_editorsnote','files_details_changeinfo','files_details_nav','files_details_nav_previous','files_details_nav_next','files_details_advertisement','files_details_social','files_details_facebook','files_details_twitter','files_details_google','files_info','files_info_size','files_info_cost','files_info_company','files_info_os','files_details_download_header','files_details_download','files_details_download_report','files_details_download_footer','files_rating_1star','files_rating_2stars','files_rating_3stars','files_rating_4stars','files_rating_5stars','files_author_posted','files_author_contributed','files_editlink','files_tags','files_tags_list','files_lightbox_header','files_lightbox_image','files_lightbox_footer','files_error_na','files_rating_form','files_comment_scripts_standard','files_comment_scripts_wysiwyg','files_password','files_subscribe_list_header','files_subscribe_list_on','files_subscribe_list_off','files_subscribe_list_footer','files_related_header','files_related_list','files_related_footer','files_comment_pagenav_header','files_comment_pagenav_first','files_comment_pagenav_previous','files_comment_pagenav_link','files_comment_pagenav_selected','files_comment_pagenav_next','files_comment_pagenav_last','files_comment_pagenav_footer','files_comment_manage_header','files_comment','files_comment_plonked','files_comment_userposts','files_comment_userregdate','files_comment_userlocation','files_comment_usertitle','files_comment_usertitle_anon','files_comment_usertitle_admin','files_comment_usertitle_moderator','files_comment_usertitle_subscriber','files_comment_usertitle_banned','files_comment_avatar','files_comment_signature','files_comment_profile','files_comment_messageicon','files_comment_options','files_comment_options_edit','files_comment_options_admin','files_comment_manage_footer','files_comment_form','files_comment_form_wysiwyg','files_comment_form_anon','files_comment_form_securitycode','files_comment_form_recaptcha','files_comment_form_icon','files_comment_form_iconrow','files_comment_form_signature','files_comment_form_external','files_error_nofile','files_error_password','files_details_footer','files_footer','files_layout_details'", $files_theme );
	$insert = $system -> getinsert( $preferences, $main_templates );
	$insert[ 'site_theme' ] = $files_theme;
	$currentdate = date( "Y-m-d H:i:s", mktime() );

	if( !$user[ 'user_nocookie' ] )
	{
    	if( !isset( $_POST[ 'input_security_hash' ] ) )
    	{
    		session_start();
    		$insert[ 'files_security_hash' ] = $system -> dorand();
    		$_SESSION[ 'files_security_hash' ] = $insert[ 'files_security_hash' ];
    	}
    	else
    	{
    		$insert[ 'files_security_hash' ] = $security -> checkvar( $_POST[ 'input_security_hash' ] );
    	}
	}
	else
	{
	    $insert[ 'files_security_hash' ] = $security -> checkvar( $_POST[ 'input_security_hash' ] );
	}

	if( $user[ 'user_status' ] == 1 )
	{
		$file_status = "(file_status = '0' OR file_status = '1' OR file_status = '3')";
		$file_status_alt = "(file_status = '0' OR file_status = '1')";
	}
	elseif( $user[ 'user_status' ] == 2 or $user[ 'user_status' ] == 3 )
	{
		$file_status = "(file_status = '0' OR file_status = '1' OR file_status = '2' OR file_status = '3' OR file_status = '4')";
		$file_status_alt = "(file_status = '0' OR file_status = '1' OR file_status = '2' OR file_status = '4')";
	}
	elseif( $user[ 'user_status' ] == 6 )
	{
		$file_status = "(file_status = '0' OR file_status = '1' OR file_status = '3' OR file_status = '4')";
		$file_status_alt = "(file_status = '0' OR file_status = '1' OR file_status = '4')";
	}
	else
	{
		$file_status = "(file_status = '0' OR file_status = '3')";
		$file_status_alt = "file_status = '0'";
	}

	if( $preferences[ 'files_start_expire_date' ] )
	{
		$files_expire_sql = " AND file_startdate < '" . $currentdate . "' AND (file_expiredate > '" . $currentdate . "' OR file_neverexpire = '1')";
	}
	else
	{
		$files_expire_sql = "";
	}

	$query = $database -> dbquery( "SELECT file_id, file_author, file_category, file_name, file_version, file_seo, file_smalldescription, file_longdescription, file_description, file_keywords, file_tags, file_size, file_cost, file_company, file_homepage, file_os, file_limitations, file_editorsnote, file_changeinfo, file_teaser, file_comments, file_thread, file_allowcomments, file_status, file_password, file_date, file_fields, file_views, file_downloads, file_rating, file_votes, file_source, file_sourceid, file_sticky FROM " . DB_PREFIX . "esselbach_ct_files WHERE file_seo = '" . $page_query . "' AND " . $file_status . " AND (file_website = '0' OR file_website = '" . intval( $config[ 'WEBSITE' ] ) . "')" . $files_expire_sql );

	if( $database -> dbrows( $query ) )
	{
		list( $insert[ 'file_id' ], $insert[ 'file_author' ], $insert[ 'file_category' ], $insert[ 'file_name' ], $insert[ 'file_version' ], $insert[ 'file_seo' ], $insert[ 'file_smalldescription' ], $insert[ 'file_longdescription' ], $insert[ 'file_description' ], $insert[ 'file_keywords' ], $insert[ 'file_tags' ], $insert[ 'file_size' ], $insert[ 'file_cost' ], $insert[ 'file_company' ], $insert[ 'file_homepage' ], $insert[ 'file_os' ], $insert[ 'file_limitations' ], $insert[ 'file_editorsnote' ], $insert[ 'file_changeinfo' ], $insert[ 'file_teaser' ], $insert[ 'file_comments' ], $insert[ 'file_thread' ], $insert[ 'file_allowcomments' ], $insert[ 'file_status' ], $insert[ 'file_password' ], $insert[ 'file_date' ], $insert[ 'file_fields' ], $insert[ 'file_views' ], $insert[ 'file_downloads' ], $insert[ 'file_rating' ], $insert[ 'file_votes' ], $insert[ 'file_source' ], $insert[ 'file_sourceid' ], $insert[ 'file_sticky' ] ) = $database -> dbrow( $query );

		if( $insert[ 'file_status' ] == 3 )
		{
			$file_password = ( isset( $_POST[ 'file_password' ] ) ) ? $security -> checkvare( $_POST[ 'file_password' ] ) : "" ;
			$input_security_hash = ( isset( $_POST[ 'input_security_hash' ] ) ) ? $security -> checkvar( $_POST[ 'input_security_hash' ] ) : "" ;

			if( !$file_password )
			{
				$file_notice = $templates -> exectemplate( $main_templates[ 'files_password_html' ], $main_templates[ 'files_password_php' ], $insert );
			}
			elseif( $file_password != $insert[ 'file_password' ] )
			{
				$file_notice = $templates -> exectemplate( $main_templates[ 'files_error_password_html' ], $main_templates[ 'files_error_password_php' ], $insert );
			}
			elseif( !$user[ 'user_nocookie' ] )
			{
				session_start();

				if( $_SESSION[ 'files_security_hash' ] != $input_security_hash )
				{
					echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );
					echo $templates -> exectemplate( $main_templates[ 'site_invalid_form_html' ], $main_templates[ 'site_invalid_form_php' ], $insert );
					echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
					exit;
				}
			}
		}

		$id = $security -> checknum( $insert[ 'file_id' ] );
		$insert[ 'file_os' ] = str_replace( ",", ", ", $insert[ 'file_os' ] );

		if( $insert[ 'file_fields' ] )
		{
			$input_fields_array = explode( "|", $insert[ 'file_fields' ] );
			$extra = 0;

			for( $i = 0; $i < 24; $i++ )
			{
				$extra++;
				$insert[ 'file_extra' . $extra ] = $system -> decode( $input_fields_array[ $i ] );
			}
		}
		else
		{
			for( $i = 1; $i < 25; $i++ )
			{
				$insert[ 'file_extra' . $i ] = "";
			}
		}

		if( $preferences[ 'files_image_lightbox' ] )
		{
			$insert[ 'file_lightbox' ] = $templates -> exectemplate( $main_templates[ 'files_lightbox_header_html' ], $main_templates[ 'files_lightbox_header_php' ], $insert );

			$query = $database -> dbquery( "SELECT filefile_id, filefile_title FROM " . DB_PREFIX . "esselbach_ct_filesfiles WHERE filefile_file = '" . $insert[ 'file_id' ] . "' AND (filefile_mime LIKE 'image%') ORDER BY filefile_id" );
			while( list( $insert[ 'filefile_id' ], $insert[ 'filefile_title' ] ) = $database -> dbrow( $query ) )
			{
				$insert[ 'file_lightbox' ] .= $templates -> exectemplate( $main_templates[ 'files_lightbox_image_html' ], $main_templates[ 'files_lightbox_image_php' ], $insert );
			}
			$insert[ 'file_lightbox' ] .= $templates -> exectemplate( $main_templates[ 'files_lightbox_footer_html' ], $main_templates[ 'files_lightbox_footer_php' ], $insert );
		}

		$insert[ 'file_size' ] = htmlspecialchars( $insert[ 'file_size' ], ENT_QUOTES, CT_ENCODING );
		$insert[ 'file_cost' ] = htmlspecialchars( $insert[ 'file_cost' ], ENT_QUOTES, CT_ENCODING );
		$insert[ 'file_company' ] = htmlspecialchars( $insert[ 'file_company' ], ENT_QUOTES, CT_ENCODING );
		$insert[ 'file_homepage' ] = htmlspecialchars( $insert[ 'file_homepage' ], ENT_QUOTES, CT_ENCODING );
		$insert[ 'file_os' ] = htmlspecialchars( $insert[ 'file_os' ], ENT_QUOTES, CT_ENCODING );

		$insert[ 'file_limitations' ] = ( $insert[ 'file_limitations' ] ) ? $templates -> exectemplate( $main_templates[ 'files_details_limitations_html' ], $main_templates[ 'files_details_limitations_php' ], $insert ) : "" ;
		$insert[ 'file_editorsnote' ] = ( $insert[ 'file_editorsnote' ] ) ? $templates -> exectemplate( $main_templates[ 'files_details_editorsnote_html' ], $main_templates[ 'files_details_editorsnote_php' ], $insert ) : "" ;
		$insert[ 'file_changeinfo' ] = ( $insert[ 'file_changeinfo' ] ) ? $templates -> exectemplate( $main_templates[ 'files_details_changeinfo_html' ], $main_templates[ 'files_details_changeinfo_php' ], $insert ) : "" ;

		if( $insert[ 'file_size' ] )
		{
			$insert[ 'file_size' ] = $templates -> exectemplate( $main_templates[ 'files_info_size_html' ], $main_templates[ 'files_info_size_php' ], $insert );
		}


		if( $insert[ 'file_cost' ] )
		{
			$insert[ 'file_cost' ] = $templates -> exectemplate( $main_templates[ 'files_info_cost_html' ], $main_templates[ 'files_info_cost_php' ], $insert );
		}


		if( $insert[ 'file_company' ] )
		{
			$insert[ 'file_company' ] = $templates -> exectemplate( $main_templates[ 'files_info_company_html' ], $main_templates[ 'files_info_company_php' ], $insert );
		}


		if( $insert[ 'file_os' ] )
		{
			$insert[ 'file_os' ] = $templates -> exectemplate( $main_templates[ 'files_info_os_html' ], $main_templates[ 'files_info_os_php' ], $insert );
		}


		if( $insert[ 'file_size' ] or $insert[ 'file_cost' ] or $insert[ 'file_company' ] or $insert[ 'file_os' ] )
		{
			$insert[ 'file_info' ] = $templates -> exectemplate( $main_templates[ 'files_info_html' ], $main_templates[ 'files_info_php' ], $insert );
		}
		else
		{
			$insert[ 'file_info' ] = "";
		}


		if( $insert[ 'file_teaser' ] )
		{
			$insert[ 'file_teaserimage' ] = $templates -> exectemplate( $main_templates[ 'files_teaserimage_html' ], $main_templates[ 'files_teaserimage_php' ], $insert );
		}
		else
		{
			$insert[ 'file_teaserimage' ] = "";
		}

		if( $preferences[ 'files_allow_rating' ] and $insert[ 'file_votes' ] )
		{
			if( $insert[ 'file_rating' ] == 5 )
			{
				$insert[ 'file_rating_line' ] = $templates -> exectemplate( $main_templates[ 'files_rating_5stars_html' ], $main_templates[ 'files_rating_5stars_php' ], $insert );
			}
			elseif( $insert[ 'file_rating' ] == 4 )
			{
				$insert[ 'file_rating_line' ] = $templates -> exectemplate( $main_templates[ 'files_rating_4stars_html' ], $main_templates[ 'files_rating_4stars_php' ], $insert );
			}
			elseif( $insert[ 'file_rating' ] == 3 )
			{
				$insert[ 'file_rating_line' ] = $templates -> exectemplate( $main_templates[ 'files_rating_3stars_html' ], $main_templates[ 'files_rating_3stars_php' ], $insert );
			}
			elseif( $insert[ 'file_rating' ] == 2 )
			{
				$insert[ 'file_rating_line' ] = $templates -> exectemplate( $main_templates[ 'files_rating_2stars_html' ], $main_templates[ 'files_rating_2stars_php' ], $insert );
			}
			elseif( $insert[ 'file_rating' ] < 2 )
			{
				$insert[ 'file_rating_line' ] = $templates -> exectemplate( $main_templates[ 'files_rating_1star_html' ], $main_templates[ 'files_rating_1star_php' ], $insert );
			}
		}
		else
		{
			$insert[ 'file_rating_line' ] = "";
		}

		if( $user[ 'user_status' ] == 2 and $insert[ 'file_author' ] == $user[ 'user_name' ] )
		{
			$insert[ 'file_edit' ] = $templates -> exectemplate( $main_templates[ 'files_editlink_html' ], $main_templates[ 'files_editlink_php' ], $insert );
		}
		else
		{
			$insert[ 'file_edit' ] = "";
		}

		if( $insert[ 'file_tags' ] )
		{
			$tags = explode( ",", $insert[ 'file_tags' ] );
			$tags_array = array();

			foreach( $tags as $tag )
			{
				if( $tag )
				{
					$insert[ 'file_tag' ] = ltrim( rtrim( $tag ) );
					$insert[ 'file_tag_seo' ] = $system -> doseo( $insert[ 'file_tag' ] );
					$tags_array[ ] = $templates -> exectemplate( $main_templates[ 'files_tags_list_html' ], $main_templates[ 'files_tags_list_php' ], $insert );
				}
			}

			$insert[ 'file_tags_list' ] = implode( ",", $tags_array );
			$insert[ 'file_tags' ] = $templates -> exectemplate( $main_templates[ 'files_tags_html' ], $main_templates[ 'files_tags_php' ], $insert );
		}

		$file_name = $insert[ 'file_name' ];
		$insert[ 'file_name' ] = htmlspecialchars( $insert[ 'file_name' ], ENT_QUOTES, CT_ENCODING );
		$insert[ 'file_version' ] = htmlspecialchars( $insert[ 'file_version' ], ENT_QUOTES, CT_ENCODING );
		$insert[ 'file_author' ] = htmlspecialchars( $insert[ 'file_author' ], ENT_QUOTES, CT_ENCODING );
		$insert[ 'file_source' ] = htmlspecialchars( $insert[ 'file_source' ], ENT_QUOTES, CT_ENCODING );

		if( $insert[ 'file_source' ] )
		{
			$insert[ 'file_author_by' ] = $templates -> exectemplate( $main_templates[ 'files_author_contributed_html' ], $main_templates[ 'files_author_contributed_php' ], $insert );
		}
		else
		{
			$insert[ 'file_author_by' ] = $templates -> exectemplate( $main_templates[ 'files_author_posted_html' ], $main_templates[ 'files_author_posted_php' ], $insert );
		}
		$insert[ 'file_month_id' ] = $system -> getmonth( $insert[ 'file_date' ] );
		$insert[ 'file_month' ] = $system -> convertdate( $insert[ 'file_date' ], "%B %Y", $preferences[ 'website_timezone' ] );
		$insert[ 'file_date' ] = $system -> convertdate( $insert[ 'file_date' ], $preferences[ 'files_dateformat' ], $preferences[ 'website_timezone' ] );

		if( $insert[ 'file_teaser' ] )
		{
			$insert[ 'file_teaserimage' ] = $templates -> exectemplate( $main_templates[ 'files_teaserimage_html' ], $main_templates[ 'files_teaserimage_php' ], $insert );
		}
		else
		{
			$insert[ 'file_teaserimage' ] = "";
		}

		if( $preferences[ 'website_advertisement_middle' ] )
		{
			$insert[ 'advertisement_middle' ] = $preferences[ 'website_advertisement_middle' ];
			$insert[ 'file_advertisement' ] = $templates -> exectemplate( $main_templates[ 'files_details_advertisement_html' ], $main_templates[ 'files_details_advertisement_php' ], $insert );
		}
		else
		{
			$insert[ 'file_advertisement' ] = "";
		}

		$insert[ 'file_name_encoded' ] = urlencode( htmlspecialchars( $insert[ 'file_name' ] . " " . $insert[ 'file_version' ], ENT_QUOTES, CT_ENCODING ) );
		$insert[ 'file_url_encoded' ] = urlencode( $system -> rewritelink( htmlspecialchars( $insert[ 'site_url' ] . "/index.php" . $insert[ 'param_ct' ] . "files" . $insert[ 'param_action' ] . "details" . $insert[ 'param_page' ] . $insert[ 'file_seo' ] . ".html", ENT_QUOTES, CT_ENCODING ) ) );

		if( $preferences[ 'files_social' ] )
		{
			$insert[ 'file_social_links' ] = "";
			$query = $database -> dbquery( "SELECT sociallink_name, sociallink_image, sociallink_link FROM ".DB_PREFIX."esselbach_ct_sociallinks WHERE sociallink_active = '1' ORDER BY sociallink_position" );

			if ($database -> dbrows( $query ) )
			{
				while( list( $sociallink_name, $sociallink_image, $sociallink_link ) = $database -> dbrow( $query ) )
				{
					$insert[ 'sociallink_name'] = $sociallink_name;
					$insert[ 'sociallink_image'] = "images/social/" . $sociallink_image;
					$insert[ 'sociallink_link'] = str_replace( array( "URL_ENCODED", "TITLE_ENCODED" ) , array( $insert[ 'file_url_encoded' ], $insert[ 'file_name_encoded' ] ), $sociallink_link );
					$insert[ 'file_social_links' ] .= $templates -> exectemplate( $main_templates[ 'site_social_html' ], $main_templates[ 'site_social_php' ], $insert );
				}
			}
			$insert[ 'file_social' ] = $templates -> exectemplate( $main_templates[ 'files_details_social_html' ], $main_templates[ 'files_details_social_php' ], $insert );
		}
		else
		{
			$insert[ 'file_social' ] = "";
		}

		if( $preferences[ 'files_facebook' ] )
		{
			$insert[ 'file_facebook' ] = $templates -> exectemplate( $main_templates[ 'files_details_facebook_html' ], $main_templates[ 'files_details_facebook_php' ], $insert );
		}
		else
		{
			$insert[ 'file_facebook' ] = "";
		}

		if( $preferences[ 'files_twitter' ] )
		{
			$insert[ 'file_twitter' ] = $templates -> exectemplate( $main_templates[ 'files_details_twitter_html' ], $main_templates[ 'files_details_twitter_php' ], $insert );
		}
		else
		{
			$insert[ 'file_twitter' ] = "";
		}

		if( $preferences[ 'files_google' ] )
		{
			$insert[ 'file_google' ] = $templates -> exectemplate( $main_templates[ 'files_details_google_html' ], $main_templates[ 'files_details_google_php' ], $insert );
		}
		else
		{
			$insert[ 'file_google' ] = "";
		}

		if( $preferences[ 'files_forum_comments' ] and $insert[ 'file_thread' ] )
		{
			$insert[ 'file_comments' ] = $uwrapper -> getcomment( $insert[ 'file_thread' ] );
		}

		$insert[ 'files_download' ] = $templates -> exectemplate( $main_templates[ 'files_details_download_header_html' ], $main_templates[ 'files_details_download_header_php' ], $insert );
		$query = $database -> dbquery( "SELECT filedownload_id, filedownload_file, filedownload_num, filedownload_name, filedownload_url, filedownload_downloads, filedownload_position FROM " . DB_PREFIX . "esselbach_ct_filesdownloads WHERE filedownload_file = '" . intval( $insert[ 'file_id' ] ) . "' ORDER BY filedownload_position" );

		while( list( $insert[ 'filedownload_id' ], $insert[ 'filedownload_file' ], $insert[ 'filedownload_num' ], $insert[ 'filedownload_name' ], $insert[ 'filedownload_url' ], $insert[ 'filedownload_downloads' ], $insert[ 'filedownload_position' ] ) = $database -> dbrow( $query ) )
		{
			$report = "";
			if( $preferences[ 'files_allow_brokenlink' ] )
			{
				if( $preferences[ 'files_allow_unregbrokenlink' ] or $user[ 'user_status' ] )
				{
					$report = $templates -> exectemplate( $main_templates[ 'files_details_download_report_html' ], $main_templates[ 'files_details_download_report_php' ], $insert );
				}
			}

			$insert[ 'filedownload_report' ] = $report;
			$insert[ 'files_download' ] .= $templates -> exectemplate( $main_templates[ 'files_details_download_html' ], $main_templates[ 'files_details_download_php' ], $insert );
		}

		$insert[ 'files_download' ] .= $templates -> exectemplate( $main_templates[ 'files_details_download_footer_html' ], $main_templates[ 'files_details_download_footer_php' ], $insert );

		if ( $preferences[ 'files_comments_wysiwyg' ] )
		{
			$insert[ 'file_comment_scripts' ] = $templates -> exectemplate( $main_templates[ 'files_comment_scripts_wysiwyg_html' ], $main_templates[ 'files_comment_scripts_wysiwyg_php' ], $insert );
		}
		else
		{
			$insert[ 'file_comment_scripts' ] = $templates -> exectemplate( $main_templates[ 'files_comment_scripts_standard_html' ], $main_templates[ 'files_comment_scripts_standard_php' ], $insert );
		}

		$files_file = $templates -> exectemplate( $main_templates[ 'files_details_html' ], $main_templates[ 'files_details_php' ], $insert );
		$input_author = $database -> dbescape( $user[ 'user_username' ] );
		$insert[ 'page_name' ] = $insert[ 'file_name' ] . " " . $insert[ 'file_version' ];
		$insert[ 'page_description' ] = htmlspecialchars( $insert[ 'file_description' ], ENT_QUOTES, CT_ENCODING );
		$insert[ 'page_keywords' ] = htmlspecialchars( $insert[ 'file_keywords' ], ENT_QUOTES, CT_ENCODING );
		$insert[ 'files_advertisement' ] = "";

		if( $preferences[ 'files_details_advertisement' ] )
		{
			$keywords_array = explode( ", ", $insert[ 'file_keywords' ] );
			$keywords_sql_array = array();

			foreach( $keywords_array as $keyword )
			{
				$keywords_sql_array[ ] = "advertisement_keywords LIKE '%" . $database -> dbescape( $keyword ) . "%'";
			}

			$keywords_sql = implode( " OR ", $keywords_sql_array );

			if( $keywords_sql )
			{
				$keywords_sql = " WHERE (" . $keywords_sql . ") AND";
			}

			$preferences[ 'files_max_details_adv' ] = intval( $preferences[ 'files_max_details_adv' ] );

			if( !$preferences[ 'files_max_details_adv' ] )
			{
				$preferences[ 'files_max_details_adv' ] = 5;
			}

			$query = $database -> dbquery( "SELECT advertisement_id, advertisement_key, advertisement_name, advertisement_text FROM " . DB_PREFIX . "esselbach_ct_advertisements" . $keywords_sql . " advertisement_impressions > '0' AND (advertisement_website = '0' OR advertisement_website = '" . intval( $config[ 'WEBSITE' ] ) . "') ORDER BY advertisement_position LIMIT " . $preferences[ 'files_max_details_adv' ] );

			if( $database -> dbrows( $query ) )
			{
				$insert[ 'files_advertisement' ] .= $templates -> exectemplate( $main_templates[ 'site_advertisement_header_html' ], $main_templates[ 'site_advertisement_header_php' ], $insert );

				while( list( $advertisement_id, $advertisement_key, $advertisement_name, $advertisement_text ) = $database -> dbrow( $query ) )
				{
					$insert[ 'advertisement_key' ] = htmlspecialchars( $advertisement_key, ENT_QUOTES, CT_ENCODING );
					$insert[ 'advertisement_name' ] = htmlspecialchars( $advertisement_name, ENT_QUOTES, CT_ENCODING );
					$insert[ 'advertisement_text' ] = htmlspecialchars( $advertisement_text, ENT_QUOTES, CT_ENCODING );
					$insert[ 'files_advertisement' ] .= $templates -> exectemplate( $main_templates[ 'site_advertisement_list_html' ], $main_templates[ 'site_advertisement_list_php' ], $insert );
					$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_advertisements SET advertisement_impressions = advertisement_impressions - 1, advertisement_views = advertisement_views + 1, advertisement_activity = now() WHERE advertisement_id = '" . $advertisement_id . "'" );
				}

				$insert[ 'files_advertisement' ] .= $templates -> exectemplate( $main_templates[ 'site_advertisement_footer_html' ], $main_templates[ 'site_advertisement_footer_php' ], $insert );
			}
		}
	}

	if( !isset( $files_file ) or( isset( $file_notice ) ) )
	{
		$files_file = "";
		$insert[ 'page_name' ] = htmlspecialchars( $preferences[ 'website_name' ], ENT_QUOTES, CT_ENCODING );
		$insert[ 'page_description' ] = htmlspecialchars( $preferences[ 'website_description' ], ENT_QUOTES, CT_ENCODING );
		$insert[ 'page_keywords' ] = htmlspecialchars( $preferences[ 'website_keywords' ], ENT_QUOTES, CT_ENCODING );
	}

	if( $preferences[ 'files_alt_site_header' ] )
	{
		echo $templates -> exectemplate( $main_templates[ 'site_header_alt_html' ], $main_templates[ 'site_header_alt_php' ], $insert );
	}
	else
	{
		echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );
	}

	if( $preferences[ 'files_navigation' ] )
	{
		if( $files_file )
		{
			$insert[ 'files_header' ] = $templates -> exectemplate( $main_templates[ 'files_details_header_html' ], $main_templates[ 'files_details_header_php' ], $insert );
		}
		else
		{
			echo $templates -> exectemplate( $main_templates[ 'files_header_html' ], $main_templates[ 'files_header_php' ], $insert );
		}
	}

	if( $files_file )
	{
		$insert[ 'files_details' ] = $files_file;
		$insert[ 'files_rating_form' ] = "";

		if( $preferences[ 'files_allow_rating' ] )
		{
			if( $preferences[ 'files_allow_unregrating' ] or $user[ 'user_status' ] )
			{
				$votes = 0;

				if( $user[ 'user_status' ] )
				{
					$query = $database -> dbquery( "SELECT filerating_id FROM " . DB_PREFIX . "esselbach_ct_filesratings WHERE filerating_file = '" . $id . "' and filerating_user = '" . intval( $user[ 'user_id' ] ) . "'" );
					$votes = $database -> dbrows( $query );
				}
				else
				{
					$uniqueid = md5( $_SERVER[ 'HTTP_USER_AGENT' ] . $ipaddr );
					$query = $database -> dbquery( "SELECT filerating_id FROM " . DB_PREFIX . "esselbach_ct_filesratings WHERE filerating_file = '" . $id . "' and filerating_uniqueid = '" . $uniqueid . "'" );
					$votes = $database -> dbrows( $query );
				}

				if( !$votes )
				{
					$insert[ 'files_rating_form' ] = $templates -> exectemplate( $main_templates[ 'files_rating_form_html' ], $main_templates[ 'files_rating_form_php' ], $insert );
				}
			}
		}

		if( $preferences[ 'files_allow_subscriptions' ] and $user[ 'user_status' ] )
		{
			$insert[ 'files_subscribe' ] = $templates -> exectemplate( $main_templates[ 'files_subscribe_list_header_html' ], $main_templates[ 'files_subscribe_list_header_php' ], $insert );
			$query = $database -> dbquery( "SELECT filesubscriber_id FROM " . DB_PREFIX . "esselbach_ct_filessubscribers WHERE filesubscriber_loginname = '" . $input_author . "' AND filesubscriber_fileid = '" . intval( $insert[ 'file_id' ] ) . "'" );

			if( $database -> dbrows( $query ) )
			{
				$insert[ 'files_subscribe' ] .= $templates -> exectemplate( $main_templates[ 'files_subscribe_list_on_html' ], $main_templates[ 'files_subscribe_list_on_php' ], $insert );
			}
			else
			{
				$insert[ 'files_subscribe' ] .= $templates -> exectemplate( $main_templates[ 'files_subscribe_list_off_html' ], $main_templates[ 'files_subscribe_list_off_php' ], $insert );
			}

			$insert[ 'files_subscribe' ] .= $templates -> exectemplate( $main_templates[ 'files_subscribe_list_footer_html' ], $main_templates[ 'files_subscribe_list_footer_php' ], $insert );
		}
		else
		{
			$insert[ 'files_subscribe' ] = "";
		}

		$insert[ 'files_related' ] = "";

		if( $preferences[ 'files_related' ] and $files_file )
		{
			$query = $database -> dbquery( "SELECT filerelated_fileid, filerelated_author, filerelated_name, filerelated_seo, filerelated_description, filerelated_date FROM " . DB_PREFIX . "esselbach_ct_filesrelated WHERE filerelated_file = '" . $id . "' LIMIT " . intval( $preferences[ 'files_max_related' ] ) );

			if( $database -> dbrows( $query ) > 1 )
			{
				$insert[ 'files_related' ] = $templates -> exectemplate( $main_templates[ 'files_related_header_html' ], $main_templates[ 'files_related_header_php' ], $insert );

				while( list( $insert[ 'filerelated_id' ], $insert[ 'filerelated_author' ], $insert[ 'filerelated_name' ], $insert[ 'filerelated_seo' ], $insert[ 'filerelated_description' ], $insert[ 'filerelated_date' ] ) = $database -> dbrow( $query ) )
				{
					$insert[ 'filerelated_title' ] = htmlspecialchars( $insert[ 'filerelated_name' ], ENT_QUOTES, CT_ENCODING );
					$insert[ 'filerelated_author' ] = htmlspecialchars( $insert[ 'filerelated_author' ], ENT_QUOTES, CT_ENCODING );
					$insert[ 'filerelated_date' ] = $system -> convertdate( $insert[ 'filerelated_date' ], $preferences[ 'file_dateformat' ], $preferences[ 'website_timezone' ] );
					$insert[ 'files_related' ] .= $templates -> exectemplate( $main_templates[ 'files_related_list_html' ], $main_templates[ 'files_related_list_php' ], $insert );
				}

				$insert[ 'files_related' ] .= $templates -> exectemplate( $main_templates[ 'files_related_footer_html' ], $main_templates[ 'files_related_footer_php' ], $insert );
			}
		}

		if( $preferences[ 'files_navigation' ] )
		{
		    $website_url_array = array();
		    $query = $database -> dbquery( "SELECT preference_website, preference_value FROM " . DB_PREFIX . "esselbach_ct_preferences WHERE preference_key = 'WEBSITE_URL' ORDER BY preference_website" );
		    while( list( $website_id, $website_url ) = $database -> dbrow( $query ) )
		    {
		        if( !count( $website_url_array ) )
		        {
		            $website_url_array[ 0 ] = $website_url;
		        }
		        $website_url_array[ $website_id ] = $website_url;
		    }

			$query = $database -> dbquery( "SELECT file_website, file_name, file_version, file_seo FROM " . DB_PREFIX . "esselbach_ct_files WHERE file_id < '" . $id . "' AND " . $file_status_alt . " AND (file_website = '0' OR file_website = '" . intval( $config[ 'WEBSITE' ] ) . "') ORDER BY file_id DESC LIMIT 1" );

			if( $database -> dbrows( $query ) )
			{
				list( $previous_website, $previous_name, $previous_version, $previous_seo ) = $database -> dbrow( $query );
				$insert[ 'files_nav_website' ] = ( $_SERVER[ 'SERVER_PORT' ] == "443" ) ? str_replace( "http://", "https://", $website_url_array[ $previous_website ] ) : $website_url_array[ $previous_website ] ;
				$insert[ 'file_nav_seo' ] = $previous_seo;
				$insert[ 'file_nav_name' ] = htmlspecialchars( $previous_name, ENT_QUOTES, CT_ENCODING );
				$insert[ 'file_nav_version' ] = htmlspecialchars( $previous_version, ENT_QUOTES, CT_ENCODING );
				$insert[ 'file_previous_file' ] = $templates -> exectemplate( $main_templates[ 'files_details_nav_previous_html' ], $main_templates[ 'files_details_nav_previous_php' ], $insert );
			}
			else
			{
				$insert[ 'file_previous_file' ] = "";
			}

			$query = $database -> dbquery( "SELECT file_website, file_name, file_version, file_seo FROM " . DB_PREFIX . "esselbach_ct_files WHERE file_id > '" . $id . "' AND " . $file_status_alt . " AND (file_website = '0' OR file_website = '" . intval( $config[ 'WEBSITE' ] ) . "') ORDER BY file_id LIMIT 1" );

			if( $database -> dbrows( $query ) )
			{
				list( $next_website, $next_name, $next_version, $next_seo ) = $database -> dbrow( $query );
				$insert[ 'files_nav_website' ] = ( $_SERVER[ 'SERVER_PORT' ] == "443" ) ? str_replace( "http://", "https://", $website_url_array[ $next_website ] ) : $website_url_array[ $next_website ] ;
				$insert[ 'file_nav_seo' ] = $next_seo;
				$insert[ 'file_nav_name' ] = htmlspecialchars( $next_name, ENT_QUOTES, CT_ENCODING );
				$insert[ 'file_nav_version' ] = htmlspecialchars( $next_version, ENT_QUOTES, CT_ENCODING );
				$insert[ 'file_next_file' ] = $templates -> exectemplate( $main_templates[ 'files_details_nav_next_html' ], $main_templates[ 'files_details_nav_next_php' ], $insert );
			}
			else
			{
				$insert[ 'file_next_file' ] = "";
			}

			$insert[ 'file_current_file' ] = $insert[ 'file_name' ] . " " . $insert[ 'file_version' ];
			$insert[ 'files_details_nav' ] = $templates -> exectemplate( $main_templates[ 'files_details_nav_html' ], $main_templates[ 'files_details_nav_php' ], $insert );
		}

		$insert[ 'files_comment_pagenav' ] = "";
		$insert[ 'files_comment_manage_header' ] = "";
		$insert[ 'files_comment' ] = "";
		$insert[ 'files_comment_manage_footer' ] = "";

		if( $preferences[ 'files_forum_comments' ] and $insert[ 'file_thread' ] )
		{
			$files_all_comments = $insert[ 'file_comments' ];
			$files_user_array = $uwrapper -> getcommentsusers( $insert[ 'file_thread' ] );
		}
		else
		{
			if( $user[ 'user_status' ] == 2 or $user[ 'user_status' ] == 3 )
			{
				$filecomment_status = "filecomment_file = '" . $id . "'";
			}
			elseif( $user[ 'user_status' ] == 4 )
			{
				$filecomment_status = "filecomment_file = '" . $id . "' AND (filecomment_plonk = '" . intval( $user[ 'user_id' ] ) . "' OR filecomment_plonk = '0')";
			}
			else
			{
				$filecomment_status = "filecomment_file = '" . $id . "' AND filecomment_plonk = '0'";
			}

			$query = $database -> dbquery( "SELECT filecomment_authorid FROM " . DB_PREFIX . "esselbach_ct_filescomments WHERE " . $filecomment_status );
			$files_all_comments = $database -> dbrows( $query );
		}

		if( $files_all_comments )
		{
			$files_profile_array = array();
			$files_usertitle_title_array = array();
			$files_usertitle_posts_array = array();
			$files_comments_pages = ceil( $files_all_comments / $preferences[ 'files_max_comments' ] );

			if( !isset( $files_user_array ) )
			{
				$files_user_array = array();

				while( list( $files_user_id ) = $database -> dbrow( $query ) )
				{
					$files_user_array[ ] = "'" . intval( $files_user_id ) . "'";
				}
			}

			$files_profile_array = $uwrapper -> getprofilesfromarray( $files_user_array );

			if( $opt )
			{
				$files_comments_dbpage = $opt - 1;
				$files_comments_page = $files_comments_dbpage * $preferences[ 'files_max_comments' ];
			}
			else
			{
				$files_comments_page = 0;
			}

			$query = $database -> dbquery( "SELECT usertitle_title, usertitle_posts FROM " . DB_PREFIX . "esselbach_ct_userstitles ORDER BY usertitle_posts" );

			while( list( $usertitle_title, $usertitle_posts ) = $database -> dbrow( $query ) )
			{
				$files_usertitle_title_array[ ] = $usertitle_title;
				$files_usertitle_posts_array[ ] = $usertitle_posts;
			}

			if( $preferences[ 'files_allow_msgicons' ] )
			{
				$files_messageicons = array();
				$query = $database -> dbquery( "SELECT messageicon_id, messageicon_image FROM " . DB_PREFIX . "esselbach_ct_messageicons" );

				while( list( $messageicon_id, $messageicon_image ) = $database -> dbrow( $query ) )
				{
					$files_messageicons[ $messageicon_id ] = $messageicon_image;
				}
			}

			if( $preferences[ 'files_forum_comments' ] and $insert[ 'file_thread' ] )
			{
				$files_comments = $uwrapper -> getcommentpage( $insert[ 'file_thread' ], $files_comments_page, $preferences[ 'files_max_comments' ] );
			}
			else
			{
				$query = $database -> dbquery( "SELECT filecomment_id, filecomment_authorid, filecomment_author, filecomment_icon, filecomment_subject, filecomment_rawtext, filecomment_text, filecomment_plonk, filecomment_signature, filecomment_smilies, filecomment_bcode, filecomment_date, filecomment_edits, filecomment_lasteditauthor, filecomment_lasteditdate, filecomment_postip, filecomment_editip FROM " . DB_PREFIX . "esselbach_ct_filescomments WHERE " . $filecomment_status . " LIMIT " . $files_comments_page . "," . $preferences[ 'files_max_comments' ] );
				$files_comments = $database -> dbrows( $query );
			}

			if( $files_comments )
			{
				if( ( $files_comments_page < $files_all_comments ) and( $files_comments_pages > 1 ) )
				{
					$insert[ 'filecomment_totalpages' ] = $files_comments_pages;
					$insert[ 'files_comment_pagenav' ] = $templates -> exectemplate( $main_templates[ 'files_comment_pagenav_header_html' ], $main_templates[ 'files_comment_pagenav_header_php' ], $insert );

					if( !$opt )
					{
						$opt = 1;
					}

					if( $files_comments_pages > 6 )
					{
						$files_comments_pages_new = $opt + 1;
						$files_comments_pages_old = $opt - 1;

						if( $files_comments_pages_new < 3 )
						{
							$files_comments_pages_cur = 3;
						}
						else
						{
							$files_comments_pages_cur = $files_comments_pages_new;
						}

						if( $opt > 2 )
						{
							$insert[ 'files_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'files_comment_pagenav_first_html' ], $main_templates[ 'files_comment_pagenav_first_php' ], $insert );
						}

						$current = $files_comments_pages_cur - 2;
						$forward = $current + 4;
						$backward = $files_comments_pages - 3;

						if( $forward > $files_comments_pages )
						{
							$insert[ 'filecomment_previous' ] = $insert[ 'file_seo' ];

							if( $files_comments_pages_old != 1 )
							{
								$insert[ 'filecomment_previous' ] .= "," . $files_comments_pages_old;
							}

							$insert[ 'files_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'files_comment_pagenav_previous_html' ], $main_templates[ 'files_comment_pagenav_previous_php' ], $insert );

							for( $i = $backward; $i <= $files_comments_pages; $i++ )
							{
								$insert[ 'filecomment_page' ] = $i;

								if( $opt == $i )
								{
									$insert[ 'files_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'files_comment_pagenav_selected_html' ], $main_templates[ 'files_comment_pagenav_selected_php' ], $insert );
								}
								else
								{
									$insert[ 'filecomment_link' ] = $insert[ 'file_seo' ];

									if( $i != 1 )
									{
										$insert[ 'filecomment_link' ] .= "," . $i;
									}

									$insert[ 'files_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'files_comment_pagenav_link_html' ], $main_templates[ 'files_comment_pagenav_link_php' ], $insert );
								}
							}
						}
						else
						{
							if( $files_comments_pages_old > 3 )
							{
								$insert[ 'filecomment_previous' ] = $insert[ 'file_seo' ];

								if( $files_comments_pages_old != 1 )
								{
									$insert[ 'filecomment_previous' ] .= "," . $files_comments_pages_old;
								}

								$insert[ 'files_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'files_comment_pagenav_previous_html' ], $main_templates[ 'files_comment_pagenav_previous_php' ], $insert );
							}

							for( $i = $current; $i < $forward; $i++ )
							{
								$insert[ 'filecomment_page' ] = $i;

								if( $opt == $i )
								{
									$insert[ 'files_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'files_comment_pagenav_selected_html' ], $main_templates[ 'files_comment_pagenav_selected_php' ], $insert );
								}
								else
								{
									$insert[ 'filecomment_link' ] = $insert[ 'file_seo' ];

									if( $i != 1 )
									{
										$insert[ 'filecomment_link' ] .= "," . $i;
									}

									$insert[ 'files_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'files_comment_pagenav_link_html' ], $main_templates[ 'files_comment_pagenav_link_php' ], $insert );
								}
							}

							$insert[ 'filecomment_next' ] = $insert[ 'file_seo' ] . "," . $files_comments_pages_new;
							$insert[ 'files_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'files_comment_pagenav_next_html' ], $main_templates[ 'files_comment_pagenav_next_php' ], $insert );
							$insert[ 'filecomment_last' ] = $insert[ 'file_seo' ] . "," . $files_comments_pages;
							$insert[ 'files_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'files_comment_pagenav_last_html' ], $main_templates[ 'files_comment_pagenav_last_php' ], $insert );
						}
					}
					else
					{
						for( $i = 1; $i <= $files_comments_pages; $i++ )
						{
							$insert[ 'filecomment_page' ] = $i;
							$insert[ 'filecomment_link' ] = $insert[ 'file_seo' ];

							if( $i != 1 )
							{
								$insert[ 'filecomment_link' ] .= "," . $i;
							}

							if( $opt == $i )
							{
								$insert[ 'files_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'files_comment_pagenav_selected_html' ], $main_templates[ 'files_comment_pagenav_selected_php' ], $insert );
							}
							else
							{
								$insert[ 'files_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'files_comment_pagenav_link_html' ], $main_templates[ 'files_comment_pagenav_link_php' ], $insert );
							}
						}
					}

					$insert[ 'files_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'files_comment_pagenav_footer_html' ], $main_templates[ 'files_comment_pagenav_footer_php' ], $insert );
				}

				$filecomment_id_array = array();
				$filecomment_authorid_array = array();
				$filecomment_author_array = array();
				$filecomment_icon_array = array();
				$filecomment_subject_array = array();
				$filecomment_rawtext_array = array();
				$filecomment_text_array = array();
				$filecomment_plonk_array = array();
				$filecomment_signature_array = array();
				$filecomment_smilies_array = array();
				$filecomment_bcode_array = array();
				$filecomment_date_array = array();
				$filecomment_edits_array = array();
				$filecomment_lasteditauthor_array = array();
				$filecomment_lasteditdate_array = array();
				$filecomment_postip_array = array();
				$filecomment_editip_array = array();
				$moderator = 0;

				if( $preferences[ 'files_forum_comments' ] and $insert[ 'file_thread' ] )
				{
					$filescomments = $uwrapper -> getcommentspage( $insert[ 'file_thread' ], $files_comments_page, $preferences[ 'files_max_comments' ] );

					foreach( $filescomments as $filecomment )
					{
						$filecomment_data = explode( "|^Z|", $filecomment );

						if( !$system -> decode( $filecomment_data[ 4 ] ) )
						{
							$filecomment_subject_array[ ] = $file_name;
						}
						else
						{
							$filecomment_subject_array[ ] = base64_decode( $filecomment_data[ 4 ] );
						}

						$filecomment_id_array[ ] = base64_decode( $filecomment_data[ 0 ] );
						$filecomment_authorid_array[ ] = base64_decode( $filecomment_data[ 1 ] );
						$filecomment_author_array[ ] = base64_decode( $filecomment_data[ 2 ] );
						$filecomment_icon_array[ ] = base64_decode( $filecomment_data[ 3 ] );
						$filecomment_rawtext_array[ ] = base64_decode( $filecomment_data[ 5 ] );
						$filecomment_text_array[ ] = base64_decode( $filecomment_data[ 6 ] );
						$filecomment_plonk_array[ ] = base64_decode( $filecomment_data[ 7 ] );
						$filecomment_signature_array[ ] = ( $preferences[ 'files_forum_signatures' ] ) ? base64_decode( $filecomment_data[ 8 ] ) : 0 ;
						$filecomment_smilies_array[ ] = base64_decode( $filecomment_data[ 9 ] );
						$filecomment_bcode_array[ ] = base64_decode( $filecomment_data[ 10 ] );
						$filecomment_date_array[ ] = base64_decode( $filecomment_data[ 11 ] );
						$filecomment_edits_array[ ] = base64_decode( $filecomment_data[ 12 ] );
						$filecomment_lasteditauthor_array[ ] = base64_decode( $filecomment_data[ 13 ] );
						$filecomment_lasteditdate_array[ ] = base64_decode( $filecomment_data[ 14 ] );
						$filecomment_postip_array[ ] = base64_decode( $filecomment_data[ 15 ] );
						$filecomment_editip_array[ ] = base64_decode( $filecomment_data[ 16 ] );
					}
				}
				else
				{
					if( $user[ 'user_status' ] == 3 and $preferences[ 'files_allow_moderators' ] )
					{
						$moderator = 1;
					}

					if( $user[ 'user_status' ] == 2 or $moderator )
					{
						$insert[ 'files_comment_manage_header' ] = $templates -> exectemplate( $main_templates[ 'files_comment_manage_header_html' ], $main_templates[ 'files_comment_manage_header_php' ], $insert );
					}

					while( list( $filecomment_id, $filecomment_authorid, $filecomment_author, $filecomment_icon, $filecomment_subject, $filecomment_rawtext, $filecomment_text, $filecomment_plonk, $filecomment_signature, $filecomment_smilies, $filecomment_bcode, $filecomment_date, $filecomment_edits, $filecomment_lasteditauthor, $filecomment_lasteditdate, $filecomment_postip, $filecomment_editip ) = $database -> dbrow( $query ) )
					{
						$filecomment_id_array[ ] = $filecomment_id;
						$filecomment_authorid_array[ ] = $filecomment_authorid;
						$filecomment_author_array[ ] = $filecomment_author;
						$filecomment_icon_array[ ] = $filecomment_icon;
						$filecomment_subject_array[ ] = $filecomment_subject;
						$filecomment_rawtext_array[ ] = $filecomment_rawtext;
						$filecomment_text_array[ ] = $filecomment_text;
						$filecomment_plonk_array[ ] = $filecomment_plonk;
						$filecomment_signature_array[ ] = $filecomment_signature;
						$filecomment_smilies_array[ ] = $filecomment_smilies;
						$filecomment_bcode_array[ ] = $filecomment_bcode;
						$filecomment_date_array[ ] = $filecomment_date;
						$filecomment_edits_array[ ] = $filecomment_edits;
						$filecomment_lasteditauthor_array[ ] = $filecomment_lasteditauthor;
						$filecomment_lasteditdate_array[ ] = $filecomment_lasteditdate;
						$filecomment_postip_array[ ] = $filecomment_postip;
						$filecomment_editip_array[ ] = $filecomment_editip;
					}
				}

				for( $c = 0; $c < count( $filecomment_id_array ); $c++ )
				{
					$insert[ 'filecomment_id' ] = intval( $filecomment_id_array[ $c ] );
					$insert[ 'filecomment_authorid' ] = intval( $filecomment_authorid_array[ $c ] );
					$insert[ 'filecomment_author' ] = htmlspecialchars( $filecomment_author_array[ $c ], ENT_QUOTES, CT_ENCODING );
					$insert[ 'filecomment_icon' ] = intval( $filecomment_icon_array[ $c ] );
					$insert[ 'filecomment_subject' ] = htmlspecialchars( $filecomment_subject_array[ $c ], ENT_QUOTES, CT_ENCODING );
					$insert[ 'filecomment_rawtext' ] = htmlspecialchars( $filecomment_rawtext_array[ $c ], ENT_QUOTES, CT_ENCODING );
					$insert[ 'filecomment_text' ] = $filecomment_text_array[ $c ];
					$insert[ 'filecomment_plonk' ] = intval( $filecomment_plonk_array[ $c ] );
					$insert[ 'filecomment_signature' ] = intval( $filecomment_signature_array[ $c ] );
					$insert[ 'filecomment_smilies' ] = intval( $filecomment_smilies_array[ $c ] );
					$insert[ 'filecomment_bcode' ] = intval( $filecomment_bcode_array[ $c ] );
					$insert[ 'filecomment_edits' ] = intval( $filecomment_edits_array[ $c ] );
					$insert[ 'filecomment_lasteditauthor' ] = htmlspecialchars( $filecomment_lasteditauthor_array[ $c ], ENT_QUOTES, CT_ENCODING );
					$insert[ 'filecomment_lasteditdate' ] = htmlspecialchars( $filecomment_lasteditdate_array[ $c ], ENT_QUOTES, CT_ENCODING );
					$insert[ 'filecomment_postip' ] = htmlspecialchars( $filecomment_postip_array[ $c ], ENT_QUOTES, CT_ENCODING );
					$insert[ 'filecomment_editip' ] = htmlspecialchars( $filecomment_editip_array[ $c ], ENT_QUOTES, CT_ENCODING );
					$insert[ 'filecomment_date' ] = $system -> convertdate( $filecomment_date_array[ $c ], $preferences[ 'files_dateformat' ], $preferences[ 'website_timezone' ] );

					if( isset( $files_profile_array[ $insert[ 'filecomment_authorid' ] ] ) )
					{
						$filecomment_author = explode( "|^Z|", $files_profile_array[ $insert[ 'filecomment_authorid' ] ] );
						$filecomment_author_regdate = explode( " ", $filecomment_author[ 2 ] );
						$insert[ 'filecomment_author' ] = $system -> decode( $filecomment_author[ 0 ] );
						$insert[ 'filecomment_author_status' ] = $filecomment_author[ 1 ];
						$insert[ 'filecomment_author_regdate' ] = $filecomment_author_regdate[ 0 ];
						$insert[ 'filecomment_author_posts' ] = $filecomment_author[ 3 ];
						$insert[ 'filecomment_author_birthday' ] = $filecomment_author[ 4 ];
						$insert[ 'filecomment_author_location' ] = $system -> decode( $filecomment_author[ 5 ] );
						$insert[ 'filecomment_author_avatar' ] = $filecomment_author[ 6 ];
						$insert[ 'filecomment_author_signature' ] = ( !$preferences[ 'files_forum_signatures' ] and !preg_match( "/Contentteller/i", $preferences[ 'website_uwrapper_product' ] ) ) ? "" : $system -> decode( $filecomment_author[ 7 ] ) ;
						$insert[ 'filecomment_author_title' ] = $system -> decode( $filecomment_author[ 8 ] );
						$insert[ 'filecomment_author_regip' ] = $filecomment_author[ 9 ];
						$insert[ 'filecomment_author_usertitle' ] = "";

						if ($insert[ 'filecomment_author_title' ])
						{
							$insert[ 'filecomment_author_usertitle' ] = $insert[ 'filecomment_author_title' ];
						}
						else
						{
							for( $i = 0; $i < count( $files_usertitle_title_array ); $i++ )
							{
								if( $filecomment_author[ 3 ] >= $files_usertitle_posts_array[ $i ] )
								{
									$insert[ 'filecomment_author_usertitle' ] = $files_usertitle_title_array[ $i ];
								}
							}
						}

						$insert[ 'filecomment_author_postsline' ] = $templates -> exectemplate( $main_templates[ 'files_comment_userposts_html' ], $main_templates[ 'files_comment_userposts_php' ], $insert );

						if( $insert[ 'filecomment_author_regdate' ] )
						{
							$insert[ 'filecomment_author_regdateline' ] = $templates -> exectemplate( $main_templates[ 'files_comment_userregdate_html' ], $main_templates[ 'files_comment_userregdate_php' ], $insert );
						}
						else
						{
							$insert[ 'filecomment_author_locationline' ] = "";
						}

						if( $insert[ 'filecomment_author_location' ] )
						{
							$insert[ 'filecomment_author_locationline' ] = $templates -> exectemplate( $main_templates[ 'files_comment_userlocation_html' ], $main_templates[ 'files_comment_userlocation_php' ], $insert );
						}
						else
						{
							$insert[ 'filecomment_author_locationline' ] = "";
						}

						if( $filecomment_author[ 1 ] == 1 or $filecomment_author[ 1 ] == 4 )
						{
							$insert[ 'filecomment_author_titleline' ] = $templates -> exectemplate( $main_templates[ 'files_comment_usertitle_html' ], $main_templates[ 'files_comment_usertitle_php' ], $insert );
						}
						elseif( $filecomment_author[ 1 ] == 2 )
						{
							$insert[ 'filecomment_author_titleline' ] = $templates -> exectemplate( $main_templates[ 'files_comment_usertitle_admin_html' ], $main_templates[ 'files_comment_usertitle_admin_php' ], $insert );
						}
						elseif( $filecomment_author[ 1 ] == 3 )
						{
							$insert[ 'filecomment_author_titleline' ] = $templates -> exectemplate( $main_templates[ 'files_comment_usertitle_moderator_html' ], $main_templates[ 'files_comment_usertitle_moderator_php' ], $insert );
						}
						elseif( $filecomment_author[ 1 ] == 5 )
						{
							$insert[ 'filecomment_author_titleline' ] = $templates -> exectemplate( $main_templates[ 'files_comment_usertitle_banned_html' ], $main_templates[ 'files_comment_usertitle_banned_php' ], $insert );
						}
						elseif( $filecomment_author[ 1 ] == 6 )
						{
							$insert[ 'filecomment_author_titleline' ] = $templates -> exectemplate( $main_templates[ 'files_comment_usertitle_subscriber_html' ], $main_templates[ 'files_comment_usertitle_subscriber_php' ], $insert );
						}
					}
					else
					{
						$insert[ 'filecomment_author_status' ] = "";
						$insert[ 'filecomment_author_regdate' ] = "";
						$insert[ 'filecomment_author_posts' ] = "";
						$insert[ 'filecomment_author_birthday' ] = "";
						$insert[ 'filecomment_author_location' ] = "";
						$insert[ 'filecomment_author_avatar' ] = "";
						$insert[ 'filecomment_author_signature' ] = "";
						$insert[ 'filecomment_author_title' ] = "";
						$insert[ 'filecomment_author_regip' ] = "";
						$insert[ 'filecomment_author_titleline' ] = $templates -> exectemplate( $main_templates[ 'files_comment_usertitle_anon_html' ], $main_templates[ 'files_comment_usertitle_anon_php' ], $insert );
						$insert[ 'filecomment_author_postsline' ] = "";
						$insert[ 'filecomment_author_regdateline' ] = "";
						$insert[ 'filecomment_author_locationline' ] = "";
					}

					if( $insert[ 'filecomment_author_avatar' ] and $user[ 'user_showavatars' ] )
					{
						$insert[ 'filecomment_author_avatarline' ] = $templates -> exectemplate( $main_templates[ 'files_comment_avatar_html' ], $main_templates[ 'files_comment_avatar_php' ], $insert );
					}
					else
					{
						$insert[ 'filecomment_author_avatarline' ] = "";
					}

					if( $insert[ 'filecomment_author_signature' ] and $user[ 'user_showsignatures' ] and $preferences[ 'files_show_signature' ] )
					{
						$insert[ 'filecomment_author_signature' ] = $system -> smilies( $system -> code( $insert[ 'filecomment_author_signature' ] ) );
						$insert[ 'filecomment_author_signatureline' ] = $templates -> exectemplate( $main_templates[ 'files_comment_signature_html' ], $main_templates[ 'files_comment_signature_php' ], $insert );
					}
					else
					{
						$insert[ 'filecomment_author_signatureline' ] = "";
					}

					if( $user[ 'user_status' ] and $insert[ 'filecomment_authorid' ] )
					{
						$insert[ 'filecomment_authorline' ] = $templates -> exectemplate( $main_templates[ 'files_comment_profile_html' ], $main_templates[ 'files_comment_profile_php' ], $insert );
					}
					else
					{
						$insert[ 'filecomment_authorline' ] = $insert[ 'filecomment_author' ];
					}

					if( $preferences[ 'files_allow_msgicons' ] and isset( $files_messageicons[ $insert[ 'filecomment_icon' ] ] ) )
					{
						$insert[ 'filecomment_messageicon' ] = $files_messageicons[ $insert[ 'filecomment_icon' ] ];
						$insert[ 'filecomment_messageicon' ] = $templates -> exectemplate( $main_templates[ 'files_comment_messageicon_html' ], $main_templates[ 'files_comment_messageicon_php' ], $insert );
					}
					else
					{
						$insert[ 'filecomment_messageicon' ] = "";
					}

					if( $user[ 'user_status' ] and !$insert[ 'file_thread' ] )
					{
						$insert[ 'filecomment_rawtext' ] = $system -> fixbreaks( addslashes( $insert[ 'filecomment_rawtext' ] ) );

						if( $user[ 'user_status' ] == 2 or $moderator )
						{
							$insert[ 'filecomment_options' ] = $templates -> exectemplate( $main_templates[ 'files_comment_options_admin_html' ], $main_templates[ 'files_comment_options_admin_php' ], $insert );
						}
						else
						{
							if( $user[ 'user_name' ] == $insert[ 'filecomment_author' ] )
							{
								$insert[ 'filecomment_options_edit' ] = $templates -> exectemplate( $main_templates[ 'files_comment_options_edit_html' ], $main_templates[ 'files_comment_options_edit_php' ], $insert );
							}
							else
							{
								$insert[ 'filecomment_options_edit' ] = "";
							}

							$insert[ 'filecomment_options' ] = $templates -> exectemplate( $main_templates[ 'files_comment_options_html' ], $main_templates[ 'files_comment_options_php' ], $insert );
						}
					}
					else
					{
						$insert[ 'filecomment_options' ] = "";
					}

					if( ( !$insert[ 'filecomment_plonk' ] ) or( $user[ 'user_status' ] == 4 and $insert[ 'filecomment_plonk' ] ) )
					{
						$insert[ 'files_comment' ] .= $templates -> exectemplate( $main_templates[ 'files_comment_html' ], $main_templates[ 'files_comment_php' ], $insert );
					}
					else
					{
						$insert[ 'files_comment' ] .= $templates -> exectemplate( $main_templates[ 'files_comment_plonked_html' ], $main_templates[ 'files_comment_plonked_php' ], $insert );
					}
				}

				if( ( $user[ 'user_status' ] == 2 or $moderator ) and( !$insert[ 'file_thread' ] ) )
				{
					$insert[ 'files_comment_manage_footer' ] .= $templates -> exectemplate( $main_templates[ 'files_comment_manage_footer_html' ], $main_templates[ 'files_comment_manage_footer_php' ], $insert );
				}
			}
		}

		if( $insert[ 'file_thread' ] )
		{
			$insert[ 'file_threadlink' ] = $uwrapper -> getthreadlink( $insert[ 'file_thread' ] );
			$insert[ 'files_comment_form' ] = $templates -> exectemplate( $main_templates[ 'files_comment_form_external_html' ], $main_templates[ 'files_comment_form_external_php' ], $insert );
		}
		else
		{
			$insert[ 'input_anon' ] = "";
			$insert[ 'input_subject' ] = "";
			$insert[ 'input_message' ] = "";

			if( $preferences[ 'files_allow_unregcomments' ] and !$user[ 'user_status' ] )
			{
				$insert[ 'file_anon' ] = $templates -> exectemplate( $main_templates[ 'files_comment_form_anon_html' ], $main_templates[ 'files_comment_form_anon_php' ], $insert );
			}
			else
			{
				$insert[ 'file_anon' ] = "";
			}

			if( $preferences[ 'files_allow_msgicons' ] )
			{
				$query = $database -> dbquery( "SELECT messageicon_id, messageicon_name, messageicon_image FROM " . DB_PREFIX . "esselbach_ct_messageicons WHERE messageicon_active = '1' ORDER BY messageicon_position" );
				$messageicon_row = 0;
				$insert[ 'file_iconrow' ] = "";

				while( list( $insert[ 'messageicon_id' ], $insert[ 'messageicon_name' ], $insert[ 'messageicon_image' ] ) = $database -> dbrow( $query ) )
				{
					$insert[ 'messageicon_name' ] = htmlspecialchars( $insert[ 'messageicon_name' ], ENT_QUOTES, CT_ENCODING );
					$insert[ 'messageicon_image' ] = htmlspecialchars( $insert[ 'messageicon_image' ], ENT_QUOTES, CT_ENCODING );

					if( !$messageicon_row )
					{
						$insert[ 'messageicon_checked' ] = "checked=\"checked\"";
					}
					else
					{
						$insert[ 'messageicon_checked' ] = "";
					}

					$messageicon_row++;

					if( $messageicon_row > $preferences[ 'files_max_msgicons' ] )
					{
						$insert[ 'messageicon_break' ] = "<br />";
						$messageicon_row = 1;
					}
					else
					{
						$insert[ 'messageicon_break' ] = "";
					}

					$insert[ 'file_iconrow' ] .= $templates -> exectemplate( $main_templates[ 'files_comment_form_iconrow_html' ], $main_templates[ 'files_comment_form_iconrow_php' ], $insert );
				}
			}

			if( $insert[ 'file_iconrow' ] )
			{
				$insert[ 'file_icon' ] = $templates -> exectemplate( $main_templates[ 'files_comment_form_icon_html' ], $main_templates[ 'files_comment_form_icon_php' ], $insert );
			}
			else
			{
				$insert[ 'file_icon' ] = "";
			}

			if( ( $user[ 'user_status' ] or $preferences[ 'files_allow_unregcomments' ] ) and $insert[ 'file_allowcomments' ] )
			{
				if( $user[ 'user_status' ] )
				{
					$input_signature = $uwrapper -> signature( $input_author );
					( $input_signature ) ? $insert[ 'input_signature_checked' ] = "checked=\"checked\"" : $insert[ 'input_signature_checked' ] = "" ;
					$insert[ 'file_signature' ] = $templates -> exectemplate( $main_templates[ 'files_comment_form_signature_html' ], $main_templates[ 'files_comment_form_signature_php' ], $insert );
				}
				else
				{
					$input_signature = 0;
					$insert[ 'file_signature' ] = "";
				}

				$insert[ 'input_smilies_checked' ] = "";
				$insert[ 'input_bcode_checked' ] = "";

				if( $preferences[ 'files_securitycode' ] )
				{
					if( ( $preferences[ 'website_recaptcha' ] ) and ( $preferences[ 'website_recaptcha_public_key' ] ) and ( $preferences[ 'website_recaptcha_private_key' ] ) and function_exists( "curl_exec" ) )
					{
						$insert[ 'website_recaptcha_public_key' ] = $preferences[ 'website_recaptcha_public_key' ];
						$insert[ 'file_securitycode' ] = $templates -> exectemplate( $main_templates[ 'files_comment_form_recaptcha_html' ], $main_templates[ 'files_comment_form_recaptcha_php' ], $insert );
					}
					elseif( function_exists( "imagestring" ) and !$user[ 'user_nocookie' ] )
					{
						$insert[ 'input_securitycode' ] = "";
						if( !isset( $_SESSION[ 'files_security_code' ] ) )
						{
							session_start();
							$_SESSION[ 'files_security_code' ] = substr( md5( $system -> dorand() ), 14, 8 );
						}
						$insert[ 'file_securitycode' ] = $templates -> exectemplate( $main_templates[ 'files_comment_form_securitycode_html' ], $main_templates[ 'files_comment_form_securitycode_php' ], $insert );
					}
				}
				else
				{
					$insert[ 'file_securitycode' ] = "";
				}

				if ( $preferences[ 'files_comments_wysiwyg' ] )
				{
					$insert[ 'files_comment_form' ] = $templates -> exectemplate( $main_templates[ 'files_comment_form_wysiwyg_html' ], $main_templates[ 'files_comment_form_wysiwyg_php' ], $insert );
				}
				else
				{
					$insert[ 'files_comment_form' ] = $templates -> exectemplate( $main_templates[ 'files_comment_form_html' ], $main_templates[ 'files_comment_form_php' ], $insert );
				}
			}
			else
			{
				$insert[ 'files_comment_form' ] = "";
			}
		}
	}
	else
	{
		if( $file_notice )
		{
			echo $file_notice;
		}
		else
		{
			echo $templates -> exectemplate( $main_templates[ 'files_error_nofile_html' ], $main_templates[ 'files_error_nofile_php' ], $insert );
		}
	}

	if( $preferences[ 'files_navigation' ] )
	{
		if( $files_file )
		{
			$insert[ 'files_footer' ] = $templates -> exectemplate( $main_templates[ 'files_details_footer_html' ], $main_templates[ 'files_details_footer_php' ], $insert );
		}
		else
		{
			echo $templates -> exectemplate( $main_templates[ 'files_header_html' ], $main_templates[ 'files_header_php' ], $insert );
		}
	}

	if( $files_file )
	{
		echo $templates -> exectemplate( $main_templates[ 'files_layout_details_html' ], $main_templates[ 'files_layout_details_php' ], $insert );
	}

	if( $preferences[ 'files_alt_site_header' ] )
	{
		echo $templates -> exectemplate( $main_templates[ 'site_footer_alt_html' ], $main_templates[ 'site_footer_alt_php' ], $insert );
	}
	else
	{
		echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
	}
}
?>